MDC (SLF4J 1.7.28 API)
Date: 2019-08-10

org.slf4j

## Class MDC

- java.lang.Object
- - org.slf4j.MDC

-     public class MDC
      extends Object

  This class hides and serves as a substitute for the underlying logging system's MDC implementation.

  If the underlying logging system offers MDC functionality, then SLF4J's MDC, i.e. this class, will delegate to the underlying system's MDC. Note that at this time, only two logging systems, namely log4j and logback, offer MDC functionality. For java.util.logging which does not support MDC, `BasicMDCAdapter` will be used. For other systems, i.e. slf4j-simple and slf4j-nop, `NOPMDCAdapter` will be used.

  Thus, as a SLF4J user, you can take advantage of MDC in the presence of log4j, logback, or java.util.logging, but without forcing these systems as dependencies upon your users.

  For more information on MDC please see the chapter on MDC in the logback manual.

  Please note that all methods in this class are static.

  Since:
    1.4.1
  Author:
    Ceki Gülcü

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MDC.MDCCloseable` An adapter to remove the key when done.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `clear()` Clear all entries in the MDC of the underlying implementation.
    `static String` | `get(String key)` Get the diagnostic context identified by the `key` parameter.
    `static Map<String,String>` | `getCopyOfContextMap()` Return a copy of the current thread's context map, with keys and values of type String.
    `static MDCAdapter` | `getMDCAdapter()` Returns the MDCAdapter instance currently in use.
    `static void` | `put(String key, String val)` Put a diagnostic context value (the `val` parameter) as identified with the `key` parameter into the current thread's diagnostic context map.
    `static MDC.MDCCloseable` | `putCloseable(String key, String val)` Put a diagnostic context value (the `val` parameter) as identified with the `key` parameter into the current thread's diagnostic context map.
    `static void` | `remove(String key)` Remove the diagnostic context identified by the `key` parameter using the underlying system's MDC implementation.
    `static void` | `setContextMap(Map<String,String> contextMap)` Set the current thread's context map by first clearing any existing map and then copying the map passed as parameter.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### put

          public static void put(String key,
                                 String val)
                          throws IllegalArgumentException

      Put a diagnostic context value (the `val` parameter) as identified with the `key` parameter into the current thread's diagnostic context map. The `key` parameter cannot be null. The `val` parameter can be null only if the underlying implementation supports it.

      This method delegates all work to the MDC of the underlying logging system.

      Parameters:
        `key` - non-null key
        `val` - value to put in the map
      Throws:
        `IllegalArgumentException` - in case the "key" parameter is null

    - #### putCloseable

          public static MDC.MDCCloseable putCloseable(String key,
                                                      String val)
                                               throws IllegalArgumentException

      Put a diagnostic context value (the `val` parameter) as identified with the `key` parameter into the current thread's diagnostic context map. The `key` parameter cannot be null. The `val` parameter can be null only if the underlying implementation supports it.

      This method delegates all work to the MDC of the underlying logging system.

      This method return a `Closeable` object who can remove `key` when `close` is called.

      Useful with Java 7 for example : `try(MDC.MDCCloseable closeable = MDC.putCloseable(key, value)) { .... }`

      Parameters:
        `key` - non-null key
        `val` - value to put in the map
      Returns:
        a `Closeable` who can remove `key` when `close` is called.
      Throws:
        `IllegalArgumentException` - in case the "key" parameter is null

    - #### get

          public static String get(String key)
                            throws IllegalArgumentException

      Get the diagnostic context identified by the `key` parameter. The `key` parameter cannot be null.

      This method delegates all work to the MDC of the underlying logging system.

      Parameters:
        `key` -
      Returns:
        the string value identified by the `key` parameter.
      Throws:
        `IllegalArgumentException` - in case the "key" parameter is null

    - #### remove

          public static void remove(String key)
                             throws IllegalArgumentException

      Remove the diagnostic context identified by the `key` parameter using the underlying system's MDC implementation. The `key` parameter cannot be null. This method does nothing if there is no previous value associated with `key`.
      Parameters:
        `key` -
      Throws:
        `IllegalArgumentException` - in case the "key" parameter is null

    - #### clear

          public static void clear()

      Clear all entries in the MDC of the underlying implementation.

    - #### getCopyOfContextMap

          public static Map<String,String> getCopyOfContextMap()

      Return a copy of the current thread's context map, with keys and values of type String. Returned value may be null.
      Returns:
        A copy of the current thread's context map. May be null.
      Since:
        1.5.1

    - #### setContextMap

          public static void setContextMap(Map<String,String> contextMap)

      Set the current thread's context map by first clearing any existing map and then copying the map passed as parameter. The context map passed as parameter must only contain keys and values of type String.
      Parameters:
        `contextMap` - must contain only keys and values of type String
      Since:
        1.5.1

    - #### getMDCAdapter

          public static MDCAdapter getMDCAdapter()

      Returns the MDCAdapter instance currently in use.
      Returns:
        the MDcAdapter instance currently in use.
      Since:
        1.4.2

Copyright © 2005–2019 QOS.ch. All rights reserved.